/***********************************************************************
 *
 * SHOWLOG.C - NetSaint Log File CGI
 *
 * Written by Ethan Galstad (netsaint@linuxbox.com)
 * Last Modified: 07-20-1999
 *
 * This CGI program will display the contents of the NetSaint
 * log file.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ***********************************************************************/

#include <stdlib.h>
#include <time.h>

#include "../common/config.h"
#include "getcgi.h"
#include "cgiutils.h"
#include "../common/common.h"

#define FIND_HOST       	1
#define FIND_CONTACT    	2

void document_header();
void document_footer();
int process_cgivars();

extern char main_config_file[MAX_FILENAME_LENGTH];
extern char url_images_path[MAX_FILENAME_LENGTH];
extern char log_file[MAX_FILENAME_LENGTH];

int main(void){
	FILE *fp;
	int error=FALSE;
	int result=OK;
	char input_buffer[MAX_INPUT_BUFFER];
	char image[MAX_INPUT_BUFFER];
	char image_alt[MAX_INPUT_BUFFER];
	time_t t;
	char *temp_buffer;
	char date_time[48];


	error=process_cgivars();

	document_header();


	time(&t);
	printf("<p><div align=\"center\">\n");
	printf("<h2>NetSaint Log File</h2>\n");
	printf("<font size=-1>\n");
	get_time_string(&t,date_time,sizeof(date_time));
	printf("Last Updated: %s",date_time);
	printf("</font>\n");
	printf("</div></p>\n");
	printf("<hr>\n");

	reset_cgi_vars();

	result=read_cgi_config_file(CGI_CONFIG_FILE);
	if(result==ERROR){
		printf("<p><div align=\"center\"><font color=\"red\"><strong>\n");
		printf("Error: Could not open CGI configuration file for reading!\n");
		printf("</strong></font></div></p>\n");
		document_footer();
		return ERROR;
	        }

	result=read_main_config_file(main_config_file);
	if(result==ERROR){
		printf("<p><div align=\"center\"><font color=\"red\"><strong>\n");
		printf("Error: Could not open main configuration file for reading!\n");
		printf("</strong></font></div></p>\n");
		document_footer();
		return ERROR;
	        }

	error=FALSE;

	fp=fopen(log_file,"r");
	if(fp==NULL){
		printf("<p><div align=\"center\">\n");
		printf("<font color=\"red\"><strong>");
		printf("Error: Could not open log file for reading!");
		printf("</strong></font>\n");
		printf("</div></p>\n");
		error=TRUE;
	        }

	if(error==FALSE){

		printf("<p>\n");
		printf("<font size=-1>\n");
		
		while(fgets(input_buffer,MAX_INPUT_BUFFER-1,fp)){

			if(strstr(input_buffer,"Warning:")){
				strcpy(image,INFO_ICON);
				strcpy(image_alt,INFO_ICON_ALT);
			        }
			else if(strstr(input_buffer," starting...")){
				strcpy(image,START_ICON);
				strcpy(image_alt,START_ICON_ALT);
			        }
			else if(strstr(input_buffer," shutting down...")){
				strcpy(image,STOP_ICON);
				strcpy(image_alt,STOP_ICON_ALT);
			        }
			else if(strstr(input_buffer,"Bailing out due to errors...")){
				strcpy(image,STOP_ICON);
				strcpy(image_alt,STOP_ICON_ALT);
			        }
			else if(strstr(input_buffer," restarting...")){
				strcpy(image,RESTART_ICON);
				strcpy(image_alt,RESTART_ICON_ALT);
			        }
			else if(strstr(input_buffer,"HOST ALERT:") && strstr(input_buffer,";DOWN;")){
				strcpy(image,HOST_CRITICAL_ICON);
				strcpy(image_alt,HOST_CRITICAL_ICON_ALT);
			        }
			else if(strstr(input_buffer,"HOST ALERT:") && strstr(input_buffer,";UNREACHABLE;")){
				strcpy(image,HOST_CRITICAL_ICON);
				strcpy(image_alt,HOST_CRITICAL_ICON_ALT);
			        }
			else if(strstr(input_buffer,"HOST ALERT:") && strstr(input_buffer,";RECOVERY;")){
				strcpy(image,HOST_RECOVERY_ICON);
				strcpy(image_alt,HOST_RECOVERY_ICON_ALT);
			        }
			else if(strstr(input_buffer,"HOST NOTIFICATION:")){
				strcpy(image,HOST_NOTIFICATION_ICON);
				strcpy(image_alt,HOST_NOTIFICATION_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE ALERT:") && strstr(input_buffer,";CRITICAL;")){
				strcpy(image,CRITICAL_ICON);
				strcpy(image_alt,CRITICAL_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE ALERT:") && strstr(input_buffer,";WARNING;")){
				strcpy(image,WARNING_ICON);
				strcpy(image_alt,WARNING_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE ALERT:") && strstr(input_buffer,";UNKNOWN;")){
				strcpy(image,UNKNOWN_ICON);
				strcpy(image_alt,UNKNOWN_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE ALERT:") && strstr(input_buffer,";RECOVERY;")){
				strcpy(image,RECOVERY_ICON);
				strcpy(image_alt,RECOVERY_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE NOTIFICATION:")){
				strcpy(image,NOTIFICATION_ICON);
				strcpy(image_alt,NOTIFICATION_ICON_ALT);
			        }
			else if(strstr(input_buffer,"SERVICE EVENT HANDLER:")){
				strcpy(image,SERVICE_EVENT_ICON);
				strcpy(image_alt,SERVICE_EVENT_ICON_ALT);
			        }
			else if(strstr(input_buffer,"HOST EVENT HANDLER:")){
				strcpy(image,HOST_EVENT_ICON);
				strcpy(image_alt,HOST_EVENT_ICON_ALT);
			        }
			else{
				strcpy(image,INFO_ICON);
				strcpy(image_alt,INFO_ICON_ALT);
			        }

			temp_buffer=strtok(input_buffer,"]");
			t=strtoul(temp_buffer+1,NULL,10);
			get_time_string(&t,date_time,sizeof(date_time));
			strip(date_time);

			temp_buffer=strtok(NULL,"\n");
			
			printf("<img align=\"left\" src=\"%s%s\" alt=\"%s\">[%s] %s<br clear=\"all\">\n",url_images_path,image,image_alt,date_time,temp_buffer);

		        }

		printf("</font>\n");
		printf("</p>\n");

		fclose(fp);
	        }

	printf("<hr>\n");

	document_footer();

	return OK;
        }




void document_header(void){

	printf("Content-type: text/html\r\n\r\n");

	printf("<html>\n");
	printf("<head>\n");
	printf("<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
	printf("<title>\n");
	printf("NetSaint Log File\n");
	printf("</title>\n");
	printf("</head>\n");
	printf("<body>\n");

	return;
        }


void document_footer(void){

	printf("</body>\n");
	printf("</html>\n");

	return;
        }


int process_cgivars(void){
	int error=FALSE;

	return error;
        }

